/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_AGRDELIVERY                                              */
/* Tabela : AGRDELIVERY                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_AGRDELIVERY' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_AGRDELIVERY
GO

CREATE TRIGGER DTULTATU_AGRDELIVERY
ON AGRDELIVERY
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'AGRDELIVERY', null, 'CDAGRDEL='+ CDAGRDEL+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE AGRDELIVERY
      SET DTULTATUAGRD = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(AGRDELIVERY.DSDELIVERY,0) = ISNULL(INSERTED.DSDELIVERY,0)) AND
            (ISNULL(AGRDELIVERY.CDAGRDEL,0)   = ISNULL(INSERTED.CDAGRDEL,0));
   END;
END;
GO

