/* Tabela DADOSENDPED: Endereo de entrega do pedido */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela DADOSENDPED */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Endereos de entrega do pedido
             utilizando a tabela Geral de Logs de Operaes */

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'LOG_PED_DADOSENDPED' and
            type = 'TR'         and
            u.uid = o.uid       and
            u.name = USER)
  DROP TRIGGER LOG_PED_DADOSENDPED
  GO

CREATE TRIGGER LOG_PED_DADOSENDPED
ON DADOSENDPED
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);
   DECLARE @V_DESC         VARCHAR(2000);
   DECLARE @V_ITPESQ       VARCHAR(40);
   DECLARE @V_NMOPERADOR   VARCHAR(40);
   DECLARE @V_IDTIPOOPER   VARCHAR(1);
   DECLARE @V_IDTPENDECLIE VARCHAR(80);

/* VARIVEIS DO CURSOR C_CURSOR*/
   DECLARE @V_ID_COMANDO       VARCHAR(1);

   DECLARE   @V_CDFILIAL_OLD VARCHAR(04);
   DECLARE   @V_NRPEDIDO_OLD VARCHAR(10);
   DECLARE   @V_NMRAZSOCPED_OLD VARCHAR(50);
   DECLARE   @V_DSENDEPED_OLD VARCHAR(50);
   DECLARE   @V_NRCEPPED_OLD VARCHAR(15);
   DECLARE   @V_NRTELEPED_OLD VARCHAR(25);
   DECLARE   @V_NRINSJURPED_OLD VARCHAR(20);
   DECLARE   @V_NRINSESTPED_OLD VARCHAR(20);
   DECLARE   @V_NMPAISPED_OLD VARCHAR(30);
   DECLARE   @V_SGESTADOPED_OLD VARCHAR(02);
   DECLARE   @V_NMMUNIPED_OLD VARCHAR(30);
   DECLARE   @V_NMBAIRROPED_OLD VARCHAR(50);
   DECLARE   @V_CDPAISPED_OLD VARCHAR(04);
   DECLARE   @V_NMESTADOPED_OLD VARCHAR(30);
   DECLARE   @V_CDMUNICIPIOPED_OLD VARCHAR(04);
   DECLARE   @V_CDCLIENTE_OLD VARCHAR(21);
   DECLARE   @V_IDTPENDECLIE_OLD VARCHAR(01);
   DECLARE   @V_NRSEQEND_OLD VARCHAR(03);

   DECLARE   @V_CDFILIAL_NEW VARCHAR(04);
   DECLARE   @V_NRPEDIDO_NEW VARCHAR(10);
   DECLARE   @V_NMRAZSOCPED_NEW VARCHAR(50);
   DECLARE   @V_DSENDEPED_NEW VARCHAR(50);
   DECLARE   @V_NRCEPPED_NEW VARCHAR(15);
   DECLARE   @V_NRTELEPED_NEW VARCHAR(25);
   DECLARE   @V_NRINSJURPED_NEW VARCHAR(20);
   DECLARE   @V_NRINSESTPED_NEW VARCHAR(20);
   DECLARE   @V_NMPAISPED_NEW VARCHAR(30);
   DECLARE   @V_SGESTADOPED_NEW VARCHAR(02);
   DECLARE   @V_NMMUNIPED_NEW VARCHAR(30);
   DECLARE   @V_NMBAIRROPED_NEW VARCHAR(50);
   DECLARE   @V_CDPAISPED_NEW VARCHAR(04);
   DECLARE   @V_NMESTADOPED_NEW VARCHAR(30);
   DECLARE   @V_CDMUNICIPIOPED_NEW VARCHAR(04);
   DECLARE   @V_CDCLIENTE_NEW VARCHAR(21);
   DECLARE   @V_IDTPENDECLIE_NEW VARCHAR(01);
   DECLARE   @V_NRSEQEND_NEW VARCHAR(03);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DSREMOTEADDR = ' ';
   SET @V_DSREMOTEHOST = ' ';
   SET @V_DSSERVERRDM  = ' ';
   SET @V_DSSERVMETHOD = ' ';
   SET @V_DSREMOTEOPER = ' ';
   SET @V_DESC         = ' ';
   SET @V_ITPESQ       = ' ';
   SET @V_NMOPERADOR   = ' ';
   SET @V_IDTIPOOPER   = ' ';
   SET @V_IDTPENDECLIE = ' ';

   EXEC NMUSUARIO @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,

         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,

         CDFILIAL,
         NRPEDIDO,
         NMRAZSOCPED,
         DSENDEPED,
         NRCEPPED,
         NRTELEPED,
         NRINSJURPED,
         NRINSESTPED,
         NMPAISPED,
         SGESTADOPED,
         NMMUNIPED,
         NMBAIRROPED,
         CDPAISPED,
         NMESTADOPED,
         CDMUNICIPIOPED,
         CDCLIENTE,
         IDTPENDECLIE,
         NRSEQEND

      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,

         INSERTED.CDFILIAL,
         INSERTED.NRPEDIDO,
         INSERTED.NMRAZSOCPED,
         INSERTED.DSENDEPED,
         INSERTED.NRCEPPED,
         INSERTED.NRTELEPED,
         INSERTED.NRINSJURPED,
         INSERTED.NRINSESTPED,
         INSERTED.NMPAISPED,
         INSERTED.SGESTADOPED,
         INSERTED.NMMUNIPED,
         INSERTED.NMBAIRROPED,
         INSERTED.CDPAISPED,
         INSERTED.NMESTADOPED,
         INSERTED.CDMUNICIPIOPED,
         INSERTED.CDCLIENTE,
         INSERTED.IDTPENDECLIE,
         INSERTED.NRSEQEND,

         DELETED.CDFILIAL,
         DELETED.NRPEDIDO,
         DELETED.NMRAZSOCPED,
         DELETED.DSENDEPED,
         DELETED.NRCEPPED,
         DELETED.NRTELEPED,
         DELETED.NRINSJURPED,
         DELETED.NRINSESTPED,
         DELETED.NMPAISPED,
         DELETED.SGESTADOPED,
         DELETED.NMMUNIPED,
         DELETED.NMBAIRROPED,
         DELETED.CDPAISPED,
         DELETED.NMESTADOPED,
         DELETED.CDMUNICIPIOPED,
         DELETED.CDCLIENTE,
         DELETED.IDTPENDECLIE,
         DELETED.NRSEQEND

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDCLIENTE  = DELETED.CDCLIENTE

      UNION ALL

      SELECT
         'I' IDCOMANDO,

         INSERTED.CDFILIAL,
         INSERTED.NRPEDIDO,
         INSERTED.NMRAZSOCPED,
         INSERTED.DSENDEPED,
         INSERTED.NRCEPPED,
         INSERTED.NRTELEPED,
         INSERTED.NRINSJURPED,
         INSERTED.NRINSESTPED,
         INSERTED.NMPAISPED,
         INSERTED.SGESTADOPED,
         INSERTED.NMMUNIPED,
         INSERTED.NMBAIRROPED,
         INSERTED.CDPAISPED,
         INSERTED.NMESTADOPED,
         INSERTED.CDMUNICIPIOPED,
         INSERTED.CDCLIENTE,
         INSERTED.IDTPENDECLIE,
         INSERTED.NRSEQEND,

         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL

      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDFILIAL_OLD,
                                 @V_NRPEDIDO_OLD,
                                 @V_NMRAZSOCPED_OLD,
                                 @V_DSENDEPED_OLD,
                                 @V_NRCEPPED_OLD,
                                 @V_NRTELEPED_OLD,
                                 @V_NRINSJURPED_OLD,
                                 @V_NRINSESTPED_OLD,
                                 @V_NMPAISPED_OLD,
                                 @V_SGESTADOPED_OLD,
                                 @V_NMMUNIPED_OLD,
                                 @V_NMBAIRROPED_OLD,
                                 @V_CDPAISPED_OLD,
                                 @V_NMESTADOPED_OLD,
                                 @V_CDMUNICIPIOPED_OLD,
                                 @V_CDCLIENTE_OLD,
                                 @V_IDTPENDECLIE_OLD,
                                 @V_NRSEQEND_OLD,

                                 @V_CDFILIAL_NEW,
                                 @V_NRPEDIDO_NEW,
                                 @V_NMRAZSOCPED_NEW,
                                 @V_DSENDEPED_NEW,
                                 @V_NRCEPPED_NEW,
                                 @V_NRTELEPED_NEW,
                                 @V_NRINSJURPED_NEW,
                                 @V_NRINSESTPED_NEW,
                                 @V_NMPAISPED_NEW,
                                 @V_SGESTADOPED_NEW,
                                 @V_NMMUNIPED_NEW,
                                 @V_NMBAIRROPED_NEW,
                                 @V_CDPAISPED_NEW,
                                 @V_NMESTADOPED_NEW,
                                 @V_CDMUNICIPIOPED_NEW,
                                 @V_CDCLIENTE_NEW,
                                 @V_IDTPENDECLIE_NEW,
                                 @V_NRSEQEND_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'I' BEGIN
         IF @V_IDTPENDECLIE_NEW = 'P' BEGIN
            SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Principal ';
         END
         ELSE BEGIN
            IF @V_IDTPENDECLIE_NEW = 'C' BEGIN
               SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Cobrana ';
            END
            ELSE BEGIN
               IF @V_IDTPENDECLIE_NEW = 'E' BEGIN
                  SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Exterior ';
               END
               ELSE BEGIN
                  IF @V_IDTPENDECLIE_NEW = 'X' BEGIN
                     SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Exportao ';
                  END
                  ELSE BEGIN
                     IF @V_IDTPENDECLIE_NEW = 'T' BEGIN
                        SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Entrega ';
                     END
                     ELSE BEGIN
                        IF @V_IDTPENDECLIE_NEW = 'O' BEGIN
                           SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Outros ';
                        END
                        ELSE BEGIN
                           IF @V_IDTPENDECLIE_NEW = 'M' BEGIN
                              SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Comercial ';
                           END
                        END;
                     END;
                  END;
               END;
            END;
         END;

         SET @V_DESC = 'Cdigo do cliente:  ' + @V_CDCLIENTE_NEW      +' '+
                         'Razao Social: '      + @V_NMRAZSOCPED_NEW    +' '+
                         'Inscricao: '         + @V_NRINSJURPED_NEW    +' '+
                         'I.E.: '              + @V_NRINSESTPED_NEW    +' '+
                                                 @V_IDTPENDECLIE       +' '+
                         'Endereco: '          + @V_DSENDEPED_NEW      +' '+
                         'Seq.: '              + @V_NRSEQEND_NEW       +' '+
                         'Bairro: '            + @V_NMBAIRROPED_NEW    +' '+
                         'CEP: '               + @V_NRCEPPED_NEW       +' '+
                         'Fone: '              + @V_NRTELEPED_NEW      +' '+
                         'Cod.Pais:  '         + @V_CDPAISPED_NEW      +' '+
                         'Nm. Pais: '          + @V_NMPAISPED_NEW      +' '+
                         'Cod.Estado: '        + @V_SGESTADOPED_NEW    +' '+
                         'Nm. Estado: '        + @V_NMESTADOPED_NEW    +' '+
                         'Cod.Municipio: '     + @V_CDMUNICIPIOPED_NEW +' '+
                         'Nm.Municipio: '      + @V_NMMUNIPED_NEW      +' ';


         SET @V_IDTIPOOPER = '1';
         SET @V_ITPESQ     = @V_CDFILIAL_NEW+@V_NRPEDIDO_NEW;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'U' BEGIN

            SET @V_DESC = 'Cd.Cliente:  '+ @V_CDCLIENTE_NEW +'  ' ;

            IF (ISNULL(@V_NMRAZSOCPED_OLD,'X') <> ISNULL(@V_NMRAZSOCPED_NEW, 'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Razao Social: ' + @V_NMRAZSOCPED_NEW +' ' ;
            END;

            IF (ISNULL(@V_NRINSJURPED_OLD,'X') <> ISNULL(@V_NRINSJURPED_NEW, 'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Inscricao: ' + @V_NRINSJURPED_NEW +' ' ;
            END;

            IF (ISNULL(@V_NRINSESTPED_OLD,'X') <> ISNULL(@V_NRINSESTPED_NEW, 'X')) BEGIN
               SET @V_DESC = @V_DESC + 'I.E.: ' + @V_NRINSESTPED_NEW +' ' ;
            END;

            IF (ISNULL(@V_DSENDEPED_OLD,'X') <> ISNULL(@V_DSENDEPED_NEW, 'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Endereco: ' + @V_DSENDEPED_NEW +' ' ;
            END;

            IF (ISNULL(@V_NRSEQEND_OLD,'X') <> ISNULL(@V_NRSEQEND_NEW, 'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Seq.: ' + @V_NRSEQEND_NEW +' ' ;
            END;

            IF (ISNULL(@V_NMBAIRROPED_OLD,'X') <> ISNULL(@V_NMBAIRROPED_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Bairro: ' + @V_NMBAIRROPED_NEW +' ' ;
            END;

            IF (@V_IDTPENDECLIE_OLD    <> @V_IDTPENDECLIE_NEW   ) BEGIN
               SET @V_DESC = @V_DESC + 'Tipo de Endereo:  ' + @V_IDTPENDECLIE_NEW  +' ' ;
            END;

            IF (ISNULL(@V_NRCEPPED_OLD,'X')  <> ISNULL(@V_NRCEPPED_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'CEP: ' + @V_NRCEPPED_NEW  +' ' ;
            END;

            IF (ISNULL(@V_NRTELEPED_OLD,'X')  <> ISNULL(@V_NRTELEPED_NEW,'X')) BEGIN
               SET @V_DESC = @V_DESC + 'Fone: ' + @V_NRTELEPED_NEW  +' ' ;
            END;

            IF (@V_CDPAISPED_OLD    <> @V_CDPAISPED_NEW   ) BEGIN
               SET @V_DESC = @V_DESC + 'Cod.Pais: ' + @V_CDPAISPED_NEW  +' ' ;
            END;

            IF (@V_NMPAISPED_OLD    <> @V_NMPAISPED_NEW   ) BEGIN
               SET @V_DESC = @V_DESC + 'Nm.Pais: ' + @V_NMPAISPED_NEW  +' ' ;
            END;

            IF (@V_SGESTADOPED_OLD    <> @V_SGESTADOPED_NEW   ) BEGIN
               SET @V_DESC = @V_DESC + 'Estado: ' + @V_SGESTADOPED_NEW  +' ' ;
            END;

            IF (@V_NMESTADOPED_OLD    <> @V_NMESTADOPED_NEW   ) BEGIN
               SET @V_DESC = @V_DESC + 'Nm.Estado: ' + @V_NMESTADOPED_NEW  +' ' ;
            END;

            IF (@V_CDMUNICIPIOPED_OLD <> @V_CDMUNICIPIOPED_NEW   ) BEGIN
               SET @V_DESC = @V_DESC + 'Cod.Municipio: ' + @V_CDMUNICIPIOPED_NEW  +' ' ;
            END;

            IF (@V_NMMUNIPED_OLD <> @V_NMMUNIPED_NEW   ) BEGIN
               SET @V_DESC = @V_DESC + 'Nm.Municipio: ' + @V_NMMUNIPED_NEW  +' ' ;
            END;



            SET @V_IDTIPOOPER = '2';
            SET @V_ITPESQ     = @V_CDFILIAL_NEW+@V_NRPEDIDO_NEW;
         END
         ELSE BEGIN
            IF @V_ID_COMANDO = 'D' BEGIN
               IF @V_IDTPENDECLIE_NEW = 'P' BEGIN
                  SET @V_IDTPENDECLIE =  'Identificador do tipo de endereo: Principal ';
               END
               ELSE BEGIN
                  IF @V_IDTPENDECLIE_OLD = 'C' BEGIN
                     SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Cobrana ';
                  END
                  ELSE BEGIN
                     IF @V_IDTPENDECLIE_OLD = 'E' BEGIN
                        SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Exterior ';
                     END
                     ELSE BEGIN
                        IF @V_IDTPENDECLIE_OLD = 'X' BEGIN
                           SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Exportao ';
                        END
                        ELSE BEGIN
                           IF @V_IDTPENDECLIE_OLD = 'T' BEGIN
                              SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Entrega ';
                           END
                           ELSE BEGIN
                              IF @V_IDTPENDECLIE_OLD = 'O' BEGIN
                                 SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Outros ';
                              END
                              ELSE BEGIN
                                 IF @V_IDTPENDECLIE_OLD = 'M' BEGIN
                                    SET @V_IDTPENDECLIE = 'Identificador do tipo de endereo: Comercial ';
                                 END;
                              END;
                           END;
                        END;
                     END;
                  END;
               END;

               SET @V_DESC = 'Cdigo do cliente:  ' + @V_CDCLIENTE_OLD      +' '+
                               'Razao Social: '      + @V_NMRAZSOCPED_OLD    +' '+
                               'Inscricao: '         + @V_NRINSJURPED_OLD    +' '+
                               'I.E.: '              + @V_NRINSESTPED_OLD    +' '+
                                                       @V_IDTPENDECLIE       +' '+
                               'Endereco: '          + @V_DSENDEPED_OLD      +' '+
                               'Seq.: '              + @V_NRSEQEND_NEW       +' '+
                               'Bairro: '            + @V_NMBAIRROPED_OLD    +' '+
                               'CEP: '               + @V_NRCEPPED_OLD       +' '+
                               'Fone: '              + @V_NRTELEPED_OLD      +' '+
                               'Cod.Pais:  '         + @V_CDPAISPED_OLD      +' '+
                               'Nm. Pais: '          + @V_NMPAISPED_OLD      +' '+
                               'Cod.Estado: '        + @V_SGESTADOPED_OLD    +' '+
                               'Nm. Estado: '        + @V_NMESTADOPED_OLD    +' '+
                               'Cod.Municipio: '     + @V_CDMUNICIPIOPED_OLD +' '+
                               'Nm.Municipio: '      + @V_NMMUNIPED_OLD      +' ';

               SET @V_IDTIPOOPER = '3';
               SET @V_ITPESQ     = @V_CDFILIAL_OLD+@V_NRPEDIDO_OLD;
            END;
         END;
      END;

      IF NOT (@V_DESC IS NULL) BEGIN

         SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);

         INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER)
                     VALUES   ('DADOSENDPED', GETDATE() ,    ISNULL(@V_NMOPERADOR,' '),
                                @V_IDTIPOOPER  , @V_DESC        , @V_ITPESQ,
                                @V_DSSERVERRDM , @V_DSREMOTEADDR, @V_DSREMOTEHOST,
                                @V_DSSERVMETHOD, @V_DSREMOTEOPER);
      END;

      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,

                                    @V_CDFILIAL_OLD,
                                    @V_NRPEDIDO_OLD,
                                    @V_NMRAZSOCPED_OLD,
                                    @V_DSENDEPED_OLD,
                                    @V_NRCEPPED_OLD,
                                    @V_NRTELEPED_OLD,
                                    @V_NRINSJURPED_OLD,
                                    @V_NRINSESTPED_OLD,
                                    @V_NMPAISPED_OLD,
                                    @V_SGESTADOPED_OLD,
                                    @V_NMMUNIPED_OLD,
                                    @V_NMBAIRROPED_OLD,
                                    @V_CDPAISPED_OLD,
                                    @V_NMESTADOPED_OLD,
                                    @V_CDMUNICIPIOPED_OLD,
                                    @V_CDCLIENTE_OLD,
                                    @V_IDTPENDECLIE_OLD,
                                    @V_NRSEQEND_OLD,

                                    @V_CDFILIAL_NEW,
                                    @V_NRPEDIDO_NEW,
                                    @V_NMRAZSOCPED_NEW,
                                    @V_DSENDEPED_NEW,
                                    @V_NRCEPPED_NEW,
                                    @V_NRTELEPED_NEW,
                                    @V_NRINSJURPED_NEW,
                                    @V_NRINSESTPED_NEW,
                                    @V_NMPAISPED_NEW,
                                    @V_SGESTADOPED_NEW,
                                    @V_NMMUNIPED_NEW,
                                    @V_NMBAIRROPED_NEW,
                                    @V_CDPAISPED_NEW,
                                    @V_NMESTADOPED_NEW,
                                    @V_CDMUNICIPIOPED_NEW,
                                    @V_CDCLIENTE_NEW,
                                    @V_IDTPENDECLIE_NEW,
                                    @V_NRSEQEND_NEW;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

